######################################
#			             #
#	     EZDB v 3.02            #
#	                             #
#			             #
#          By Stephane Barde   	     #
#        (webmaster@ezperl.com)      #
#	     January 31 2000         #
#				     #	
#     http://www.ezperl.com	     #
#				     #												 
######################################

# COPYRIGHT NOTICE:
#
# Copyright 1998-2001 Stephane Barde.  All Rights Reserved.
#
# This program is being distributed as a FREEWARE. 
#
# It may be used and modified by anyone, as long as this copyright notice and the header
# above remain intact, but any usage should be registered.  (See the
# chapter XIII- for registration information.)  By using this
# program you agree to indemnify Stephane Barde from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Contributions are welcome and will be used exclusively to enhance
# the script (contact EZ Perl at webmaster@ezperl.com)

# I would off course appreciate to have some feedback about the
# use you are doing with this script.

# It also would be nice to make a link to the EZ Perl site:
# http://www.ezperl.com

#############################################
##        display_global_variables     	   ##
#############################################

sub display_global_variables
{
my $file=$generic_html_file_path.'/'.$language.'_global_variables.html';
open(HTML,"<$file") || &display_error_message(&get_msg(69));
flock(HTML,1);
my @lines=<HTML>;
close(HTML);

$content.=join('',@lines);

$content=~ s/_language/$language/;
$content=~ s/_script_name/$script_name/;
$content=~ s/_session_max_duration/$session_max_duration/;
$content=~ s/_script_url/$script_url/;
$content=~ s/_log_archiving_duration/$log_archiving_duration/;
$content=~ s/_enable_ip_check/$enable_ip_check/;
$content=~ s/_max_invalid_attempt/$max_invalid_attempt/;
$content=~ s/_password_expiration/$password_expiration/;
$content=~ s/_setup_on/$setup_on/;
$content=~ s/_system_file_path/$system_file_path/;
$content=~ s/_generic_html_file_path/$generic_html_file_path/;
$content=~ s/_default_html_template/$default_html_template/;
$content=~ s/_eztree_html_directory/$eztree_html_directory/;
$content=~ s/_eztree_data_directory/$eztree_data_directory/;
$content=~ s/_eztree_html_url/$eztree_html_url/;
$content=~ s/_eztree_html_template/$eztree_html_template/;
$content=~ s/_eztree_html_content/$eztree_html_content/;
$content=~ s/_mail_from/$mail_from/;
$content=~ s/_mail_signature/$mail_signature/;
$content=~ s/_mail_routine_path/$mail_routine_path/;
$content=~ s/_version/$version/;
$content=~ s/_eztree_version/$eztree_version/;
$content=~ s/_ip_log_restriction/$ip_log_restriction/;
$content=~ s/_use_cookie_session/$use_cookie_session/;
$content=~ s/_eztree_on/$eztree_on/;

&display_output;
}

#############################################
##        process_global_variables     	   ##
#############################################

sub process_global_variables
{
open(EZ,"<ezdb_setup.pl") || &display_error_message(&get_msg(83));
flock(EZ,1);
my @lines=<EZ>;
close(EZ);

open(EZ,">ezdb_setup.pl") || &display_error_message(&get_msg(83));
flock(EZ,2);

foreach $line (@lines)
{
	if ($line =~ /^\$(\w+)=/)
	{
		my $var=$1;
		if (grep {$_ eq $var} keys(%in)) 
		{
			if ($in{"$var"} =~ /\D/) {print EZ "\$$var='".$in{"$var"}."';\n"}
			else {print EZ "\$$var=".$in{"$var"}.";\n"}
		}
		else {print EZ $line}
	}
	else {print EZ $line}
}

		
close(EZ);

$language=$in{'language'};

&display_global_variables;
}


##############################
##        DB_BUILDER        ##
##############################


sub db_builder_form
{
my ($action, $alias);
if ($wizard) 
{
	$action="$table_alias+ezwizard+step2&$session";
	$alias=qq!
	<tr bgcolor="#006699"><td><font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
	Database Name</font></td><td><input type=text name=db_name></td></tr>
	!;
}
else {$action="$table+db_builder+build&$session"}

$content.= qq!
<br><br>
<form action="$script_name?$action" method=post>
<center>
 <table border=1 cellpadding="0" cellspacing="0">
<tr bgcolor="#000066">
<td colspan=2><font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
<b>DATABASE Builder</b> Step 1(x) 2( )</font></td></tr>
$alias
<tr bgcolor="#006699"><td><font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Path to the database file</font></td><td><input type=text name=file value="./my_db/"></td></tr>
<tr bgcolor="#006699"><td><font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">Separator</font>
</td><td><input type=text size=3 name=separator value="|"></td></tr>
!;
if ($phase ne "edit")
{
	$content.= qq!
	<tr bgcolor="#006699"><td valign=top><font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
	Fields</font>
	</td><td><textarea name=fields rows=15 cols=20>1 field per line</textarea></td></tr>
	!;
}

$content.= qq!
<tr bgcolor="#000066"><td colspan=2 align=middle>
<input type=submit value=submit></td></tr>
</table>
</form>
!;
}

##################################
##        create_db	        ##
##################################

sub create_db {

if (-e $in{'file'}) {undef $wizard; local $create=1; &edit_db}
else {

open(DB,">$in{'file'}")||&display_error_message("Cannot print to the DB file: $in{'file'}");
flock(DB,2);

my @fields=split /\r\n/, $in{'fields'};

my $def_line=join($in{'separator'},@fields);
$def_line=~s/\s/_/g;

print DB "pkey".$in{'separator'}.$def_line."\n";
close(DB);

my $fields=join('<br>',@fields);

$content.= qq!
<br><br>
<center><table border=1>
<tr bgcolor="#000066"><td colspan=2>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
<b>DATABASE Builder</b> Step 1( ) 2(x)</font></td></tr>
<tr bgcolor="#006699"><td><b><i>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
File successfuly generated</font></i></b></td></tr>
<tr bgcolor="#006699"><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Path to the database file</font></td><td>$in{'file'}</td></tr>
<tr bgcolor="#006699"><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Separator</font></td><td>$in{'separator'}</td></tr>
<tr bgcolor="#006699"><td valign=top>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Fields</font></td><td>$fields</td></tr>
</table>
!;
}

if ($wizard)
{
	$content.= qq!
	<br><br>
	<form action="$script_name?$in{'db_name'}+ezwizard+step3&$session" method=post>
	<input type=hidden name=file value="$in{'file'}">
	<input type=hidden name=separator value="$in{'separator'}">
	<input type=hidden name=db_name value="$in{'db_name'}">
	<input type=submit value="AutoGenerate HTML's">
	</form>
	!;
	&update_system_db;
}


}

##################################
##        edit_db	        ##
##################################

sub edit_db {

if (! -e $in{'file'}) {&display_error_message("The database you specified does not exist")}
else {
open(DB,"<$in{'file'}")||&display_error_message("Cannot open the DB file: $in{'file'}");
flock(DB,1);
my @lines=<DB>;
close(DB);

my $fields=join("\n",split /\Q$in{'separator'}/, shift(@lines));


$content.= qq!
<br><br>
<form action="$script_name?.+db_builder+update&$session" method=post>
<center><table border=1>
<tr bgcolor="#000066"><td colspan=32>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
<b>DATABASE Editor</b> Step 1(x) 2( )</font></td></tr>
<tr bgcolor="#006699"><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Path to the database file</font></td><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
$in{'file'}</font></td></tr>
<tr bgcolor="#006699"><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
Separator</font></td><td>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">
$in{'separator'}</font></td></tr>
<tr bgcolor="#006699"><td valign=top>
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">Fields
<br><input type=radio name=update value="all" checked>
 Update Entire DB </font>
<br><input type=radio name=update value="names"> 
<font color="#FFFFFF" size="2" face="Verdana, Arial, Helvetica, sans-serif">Update Fields Name Only </font>
</td><td><textarea name=fields rows=15 cols=20>$fields</textarea></td></tr>
<tr bgcolor="#000066"><td colspan=2 align=middle>
<input type=hidden name=file value="$in{'file'}">
<input type=hidden name=separator value="$in{'separator'}">
<input type=submit value=submit></td></tr>
</table>
</form>
!;
}

}

##################################
##        update_db	        ##
##################################

sub update_db {

if (! -e $in{'file'}) {&display_error_message("The database you specified does not exist")}
else {
open(DB,"<$in{'file'}")||&display_error_message("Cannot open the DB file: $in{'file'}");
flock(DB,1);
my @lines=<DB>;
close(DB);

rename($in{'file'},"$in{'file'}.bak");

my @old_fields=split /\Q$in{'separator'}/, shift(@lines);
chomp $old_fields[$#old_fields];
$in{'fields'}=~ s/(\r\n)+/\r\n/g;
my @fields=split /\r\n/, $in{'fields'};

my @indexes;
$indexes{'pkey'}=0;

open(DB,">$in{'file'}")||&display_error_message("Cannot open the DB file: $in{'file'}");
flock(DB,2);

print DB join($in{'separator'},@fields),"\n";

if ($in{'update'} eq "all") 
{
	for ($i=0;$i<@old_fields;$i++)	{	if (grep {$_ eq $old_fields[$i]} @fields) {$indexes{"$old_fields[$i]"}=$i} }
	foreach $field (@fields) { if (! grep {$_ eq $field} @old_fields) {$indexes{"$field"}=-1;} }
		
	
	for (@lines)
	{
		if ($_ eq "\n") {next}
		my @new_line;
		my @old_line=split(/\Q$in{'separator'}/);
		chomp $old_line[$#old_line];
		
		foreach $field (@fields) 
		{
			if ($field eq "") {next}
			if ($indexes{"$field"} > -1) {push(@new_line,$old_line[$indexes{"$field"}]);}
			else {push(@new_line,'');}
		}
		print DB join($in{'separator'},@new_line),"\n";
	}
	
	
	
}

else { for (@lines) {print DB $_;} }

close(DB);		

		
my $fields=join('<br>',@fields);

$content.= qq!
<br><br><center>
<table border=1 cellpadding="0" cellspacing="0">
    <tr bgcolor="#000066"> 
      <td colspan=2><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF"><b>DATABASE 
        Editor</b> Step 1( ) 2(x)</font></td>
    </tr>
    <tr bgcolor="#006699"> 
      <td colspan=2><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF"><b><i>Database 
        successfuly updated</i></b></font></td>
    </tr>
    <tr bgcolor="#006699"> 
      <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">Path 
        to the database file</font></td>
      <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">$in{'file'}</font></td>
    </tr>
    <tr bgcolor="#006699"> 
      <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">Separator</font></td>
      <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">$in{'separator'}</font></td>
    </tr>
    <tr bgcolor="#006699"> 
      <td valign=top><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">Fields</font></td>
      <td><font size="2" face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF">$fields</font></td>
    </tr>
    <tr> 
      <td colspan=2 align=middle> </td>
    </tr>
  </table>
  </center>
!;
}

}

########################################
#	   update_system_db	       #
########################################

sub update_system_db
{
my $time=time;
	
open(DB,">>$system_file_path/user_rights")||&display_error_message("Cannot open user_rights from update_system_db");
flock(DB,2);
print DB $time.'|admin|'.$in{'db_name'}.'|admin_group'."\n";
close(DB);

open(DB,">>$system_file_path/table_group")||&display_error_message("Cannot open table_group from update_system_db");
flock(DB,2);
print DB $time.'|'.$in{'db_name'}.'|admin_group|1|1|1|1|1|1|1|1|1|1|Default|Default||'."\n";
$time++;
print DB $time.'|'.$in{'db_name'}.'|default|1|1|||1|1|||1|1|Default|Default||'."\n";
close(DB);
	
}

########################################
#	   bulk_update_html	       #
########################################

sub bulk_update_html {

if ($table eq '.') {&display_error_message("You must connect to a database to use the Bulk Update");}
	
if ($html_output_dir eq "") {&display_error_message("You must define an HTML Output Directory for this database before using Bulk Update");}
else
{
	
	if (! -e $html_output_dir) {&display_error_message("The HTML Output Directory $html_output_dir doesn't exist");}
	else {
	open(TABLE, "<$table") || &display_error_message("Cannot open $table");
	flock(TABLE,1);
	my @lines = <TABLE>;
	close(TABLE);

	my $column= shift(@lines);
	chomp $column;
	
	my @column=split /\Q$separator/, $column;
	
	open(HTML, "<$html_display_path") || &display_error_message("Cannot open HTML display $html_display_path");
	flock(HTML,1);
	my @html = <HTML>;
	close(HTML);

	my $global_line=join('',@html);

	$global_line =~ s/<form(.+?)_DETAIL_(.+?)<\/form>//;

	$_=$global_line;
	if (/_MENU_/) { &system_menu; $global_line=~ s/_MENU_/$system_menu/;}
	if (/href="%%(.+?)~(.+?):(.+?)"/)
	{ my $val="'".$rec{"$1"}."'"; $val=~s/\s/\+/g;
  	if ($val eq "''") {$global_line =~s/<a(.+?)?href="%%(.+?)<\/a>//;}
  	else {$global_line=~ s/href="%%(.+?)~(.+?):(.+?)"/href="$script_name?$2+search+retrieve&$session&1-1&$3=$val"/; }
	  
	}

	

	foreach $line (@lines)
	{
		
		my $temp_line=$global_line;
		chomp $line;
		my @record=split /\|/, $line;
		
		my $i=0;
		my $j=0;
		my %rec;
		

			
		for (@column)
		{
			$rec{"$_"}=$record[$j];
			$j++;
		}

		my $key=$rec{"$name_file_after"}; 
		
		sub bylength {length $a <=> length $b;}
		#@column=reverse sort bylength @column;

		for (reverse sort bylength @column)
		{
			if ($column[$i] ne "") 
				{$temp_line=~ s/\_$column[$i](\W?)/$rec{"$column[$i]"}$1/g;}
			$i++;
		}
			
		$key=~s/ /_/g;
		open(HTML,">$html_output_dir/$key.$files_extension")||&display_error_message("Cannot write to the HTML Output Directory");
		flock(HTML,2);
		print HTML $temp_line;
		close(HTML);

	}
	
	&display_error_message(&get_msg(86));
	
	
	} # end else


		
} # end global if
	
}


#################################################
#		generate_eztree			#
#################################################

sub generate_eztree
{

$content.= qq!<font face="Verdana, Arial, Helvetica, sans-serif" size="2">Generating EzTree</font><br><br>!;

my $no_of_file=0;

open(CAT,"<$eztree_data_directory/categories.csv") || &display_error_message("Unable to find the categories.csv data file under $eztree_data_directory/");
flock(CAT,1);
my @lines=<CAT>;
close(CAT);


my %cat_columns;
$_=$lines[0];
chomp;
my $i=0;
for (split(/\|/)) {$cat_columns{$_}=$i;$i++}

$lines[0]='||Index|||Welcome to EzTree. This is the index page.';

open(HTML,"<$eztree_html_directory/tree_display.html")|| &display_error_message("Unable to find the EzTree html template file under $eztree_html_directory/");
flock(HTML,1);
@html_lines=<HTML>;
close(HTML);

open(DB,"<$eztree_data_directory/eztree.csv") || &display_error_message("Unable to find the eztree.csv data file under $eztree_data_directory/");
flock(DB,1);
@dblines=<DB>;
close(DB);

my %tree_columns;
$_=shift @dblines;
chomp;
$i=0;
for (split(/\|/)) {$tree_columns{$_}=$i;$i++}

foreach $record (@lines)
{
$_=$record;
/^(\d+?)\|/;
my $cat=$1;
my $html=join('',@html_lines);

my ($master,@this_category, $subcategories, $subcategories_html, $items, $items_html, %res, %subcategories, %items);

for (@lines)
{
my @temp=split(/\|/);
if ($temp[0] eq $cat) {$cat_long_name=$temp[3];@this_category=@temp}
if (($temp[1] eq $cat)&&($_ ne $lines[0])) {@{$res{$temp[2]}}=@temp}
}

$html=~ s/_CATEGORY_/$cat_long_name/g;
if ($html =~ /<subcategories>((.|\n)+?)<\/subcategories>/) {$subcategories_html=$1}
if ($html =~ /<items>((.|\n)+?)<\/items>/) {$items_html=$1}

for (sort keys(%res))
{ 
my $html_line=$subcategories_html;
$html_line=~ s/_SUBCATEGORIES_/$eztree_html_url\/eztree_${$res{$_}}[0].html/g;
$html_line=~ s/%(\w+)%/${$res{$_}}[$cat_columns{$1}]/g;
$html_line=~ s/_SELECT_//g;

$subcategories.=$html_line;
}



foreach $line (@dblines)
{
chomp $line;
my @temp=split /\|/, $line;
if ($temp[3] eq $cat) {$items{$temp[1]}=[@temp]} 
}

sort values(%items);

for (keys(%items))
{
my $html_line=$items_html;
$html_line=~ s/%(\w+)%/${$items{$_}}[$tree_columns{$1}]/g;
$items.=$html_line;
}


$html=~ s/<subcategories>(.|\n)+?<\/subcategories>/$subcategories/g;
$html=~ s/<items>(.|\n)+?<\/items>/$items/g;
$html=~ s/%(\w+)%/$this_category[$cat_columns{$1}]/g;

my $file_name;
if ($cat eq '') {$file_name='eztree'} else {$file_name="eztree_$cat"}

open(TREE,">$eztree_html_directory/$file_name.html")|| &display_error_message("Unable to write to the EzTree html output directory $eztree_html_directory/");;
flock(TREE,2);
print TREE $html;
close(TREE);

$no_of_file++;

} #end foreach $record

$content.= qq!
<font face="Verdana, Arial, Helvetica, sans-serif" size="2">
$no_of_file files generated<br>
Access the home page: 
<a href="javascript:var w=window.open('$eztree_html_url/eztree.html','','width=500,height=350,scrollbars,resizable=yes')">eztree.html</a>
</font>
!;

}


#################################################
#		Upgrade_form			#
#################################################

sub upgrade_form
{
$content.= qq!
<font face="Verdana, Arial, Helvetica, sans-serif" size="2">
<form action="$script_name?.+upgrade+done&$session" method=post>
Which version are you upgrading from?:
<select name=version>
<option value="2.63">2.63
<option value="2.63">2.62
<option value="2.63">2.61
<option>2.6
<option>2.5
<option value="2.1">Any 2.1
<option>2.0
</select>
 
<input type=submit value="Upgrade System Files">
</form>
<br>
<b>Note:</b> <br>
The upgrade feature performs a check on the system files located by default under ./system_db.<br>
You should upgrade the HTML files manually by unzipping the current version package and posting the HMTL system files where appropriate (by default, under ./system_db_html).
</font>
!;

}

#################################################
#		Upgrade				#
#################################################

sub upgrade
{

my $add_to_tables, $add_to_table_group;

open(DB, "<$system_file_path/tables") || &display_error_message("Cannot open the <i>tables</i> system file");
flock(DB,1);
my @table_lines = <DB>;
close(DB);

my @temp_tables=split /\|/, $table_lines[0];

open(DB, "<$system_file_path/table_group") || &display_error_message("Cannot open the <i>table_group</i> system file");
flock(DB,1);
my @table_group_lines = <DB>;
close(DB);

my @temp_table_group=split /\|/, $table_group_lines[0];


if ( (($#temp_tables != 34)&&($temp_tables[$#temp_tables] ne 'bulk_delete')&&($in{'version'} eq '2.63'))
|| (($#temp_tables != 31)&&($temp_tables[$#temp_tables] ne 'eztree_fields')&&($in{'version'} eq '2.6'))
|| (($#temp_tables != 30)&&($temp_tables[$#temp_tables] ne 'name_file_after')&&($in{'version'} eq '2.5'))
|| (($#temp_tables != 28)&&($temp_tables[$#temp_tables] ne 'direct_full_display')&&($in{'version'} eq '2.1'))
|| (($#temp_tables != 20)&&($temp_tables[$#temp_tables] ne 'notify_rollback')&&($in{'version'} eq '2.0')) )
 {&display_error_message("The version $in{'version'} is not recognized")}

elsif ($in{'version'} eq '2.63') {$add_to_tables='|bad_words'}
elsif ($in{'version'} eq '2.6') {$add_to_tables='|password_field|no_match_page|bulk_delete|bad_words'}
elsif ($in{'version'} eq '2.5') {$add_to_tables='|eztree_fields|password_field|no_match_page|bulk_delete|bad_words'}

if ($in{'version'} < 2.5) 
{
	if ( (($#temp_table_group != 17)&&($temp_table_group[$#temp_table_group] ne 'html_header_footers')&&($in{'version'} eq '2.1'))
	|| (($#temp_table_group != 16)&&($temp_table_group[$#temp_table_group] ne 'access_restriction')&&($in{'version'} eq '2.0')) )
	{&display_error_message("The version $in{'version'} is not recognized")}
	elsif  ($in{'version'} eq '2.1')
	{$add_to_tables='|files_extension|name_file_after|eztree_fields|password_field|no_match_page|bulk_delete|bad_words';
	$add_to_table_group='|direct_full_display|authorized_fields|default_values|display_line_html';
	}
	elsif  ($in{'version'} eq '2.0')
	{$add_to_tables='|show_percentage|html_output_dir|html_output_url|target_dir|target_dir_url|max_image_size|order_by|direct_full_display|files_extension|name_file_after|eztree_fields|password_field|no_match_page|bulk_delete|bad_words';
	$add_to_table_group='|html_header_footers|direct_full_display|authorized_fields|default_values|display_line_html';
	}
}
elsif ($in{'version'} < 3)  { $add_to_table_group='|authorized_fields|default_values|display_line_html'; }
	


if ($add_to_tables) {
$table_lines[0]=~ s/\n$/$add_to_tables\n/;
rename "$system_file_path/tables", "$system_file_path/tables.old";
open(DB, ">$system_file_path/tables") || &display_error_message("Cannot write to the <i>tables</i> system file");
flock(DB,2);
for (@table_lines) {print DB}
close(DB);

$content.= qq!
<li> <b>tables</b> system file upgraded properly. Previous <b>tables</b> system file renamed into table.old
!;
}

if ($add_to_table_group) {
$table_group_lines[0]=~ s/\n$/$add_to_table_group\n/;
rename "$system_file_path/table_group", "$system_file_path/table_group.old";
open(DB, ">$system_file_path/table_group") || &display_error_message("Cannot write to the <i>table_group</i> system file");
flock(DB,2);
for (@table_group_lines) {print DB}
close(DB);

$content.= qq!
<li> <b>table_group</b> system file upgraded properly. Previous <b>table_group</b> system file renamed into table_group.old
!;
}

if  ($in{'version'} eq '2.0')
{
# we create add_external if needed
unless (-e "$system_file_path/add_external")
{

open(DB, ">$system_file_path/add_external") || &display_error_message("Cannot write to the <i>table_group</i> system file");
flock(DB,2);
print DB 'pkey|table|ftable|fields'."\n";
close(DB);

$content.= "<li> <b>add_external</b> system file generated properly.";
	
}


} # v2.0

if ($in{'version'} < 3)  
{
	# update user_session for ip checking and second_key
	rename "$system_file_path/user_session", "$system_file_path/table_group.old";
	open(DB, ">$system_file_path/user_session") || &display_error_message("Cannot write to the <i>table_group</i> system file");
	flock(DB,2);
	print DB 'pkey|group|login|date|ip|second_key'."\n";
	close(DB);

	$content.= qq!
	<li> <b>user_session</b> system file upgraded properly. Previous <b>user_session</b> system file renamed into table_group.old <b>WARNING</b>
	you have been disconnected due to user_session update (this is normal), please sign in again. 
	!;
	
open(DB, "<$system_file_path/user_data") || &display_error_message("Cannot open the <i>user_data</i> system file");
flock(DB,1);
my @user_data_lines = <DB>;
close(DB);

$user_data_lines[0]='pkey|login|password|name|block|email|ip'."\n";
rename "$system_file_path/user_data", "$system_file_path/user_data.old";
open(DB, ">$system_file_path/user_data") || &display_error_message("Cannot write to the <i>user_data</i> system file");
flock(DB,2);
for (@user_data_lines) {print DB}
close(DB);	
}


}

1;